#include <windows.h>
#include <wsipx.h>

#include <stdio.h>
#include <string.h>
#include <conio.h>

void main (int argc, char *argv[])
{
	WORD	version;
	WSADATA	wsaData;
	SOCKET	s;
	SOCKADDR_IPX	localAddr;
	char sendBuff[4096];
	char tempBuff[20];
	int bytesToSend;
	int error;
	int addrLen = sizeof (localAddr);
	int i;

	strcpy (sendBuff, "");
	for (i = 1; i < argc; i++)
	{
		strcat (sendBuff, argv[i]);
		strcat (sendBuff, " ");
	}

	version = MAKEWORD (1,1);
	if (WSAStartup (version, &wsaData) == SOCKET_ERROR)
	{
		printf ("WSAStartup failed\n");
		return;
	}

	s = socket (AF_IPX, SOCK_STREAM, NSPROTO_SPX);
	if (s == INVALID_SOCKET)
	{
		error = WSAGetLastError ();
		printf ("Error %d on socket\n", error);
		WSACleanup ();
		return;
	}
	printf ("socket() successful\n");

	memset (&localAddr, 0, sizeof (localAddr));
	localAddr.sa_family = AF_IPX;
	localAddr.sa_socket = 0xA791;
	localAddr.sa_netnum[0] = 0x01;
	localAddr.sa_netnum[1] = 0x01;
	localAddr.sa_netnum[2] = 0x00;
	localAddr.sa_netnum[3] = 0x40;
	localAddr.sa_nodenum[0] = 0x00;
	localAddr.sa_nodenum[1] = (char)0xC0;
	localAddr.sa_nodenum[2] = 0x4F;
	localAddr.sa_nodenum[3] = (char)0xDE;
	localAddr.sa_nodenum[4] = 0x73;
	localAddr.sa_nodenum[5] = (char)0xA6;

	if (connect (s, (LPSOCKADDR)&localAddr, sizeof (localAddr)) == SOCKET_ERROR)
	{
		error = WSAGetLastError ();
		printf ("Error %d on connect\n");
		WSACleanup ();
		return;
	}
	printf ("connect() successful\n");

	bytesToSend = strlen (sendBuff);
	tempBuff[0] = bytesToSend;

	if (send (s, tempBuff, sizeof (int), 0) == SOCKET_ERROR)
	{
		error = WSAGetLastError ();
		printf ("Error %d on send\n");
		WSACleanup ();
		return;
	}
	printf ("send() successful\n");

	if (recv (s, tempBuff, 20, 0) == SOCKET_ERROR)
	{
		error = WSAGetLastError ();
		printf ("Error %d on recv\n");
		WSACleanup ();
		return;
	}

	if (stricmp (tempBuff, "OK") == 0)
	{
		if (send (s, sendBuff, bytesToSend, 0) == SOCKET_ERROR)
		{
			error = WSAGetLastError ();
			printf ("Error %d on send\n");
			WSACleanup ();
			return;
		}
		if (recv (s, sendBuff, 4096, 0) == SOCKET_ERROR)
		{
			error = WSAGetLastError ();
			printf ("Error %d on recv\n");
			WSACleanup ();
			return;
		}
		printf ("Got back %s\n", sendBuff);
	}

	closesocket (s);
	WSACleanup ();
}